#ifndef LOADABLE_H_
#define LOADABLE_H_

#include <stdio.h>
#include <glib-object.h>

#define U_OBJECT_TYPE_LOADABLE (u_object_loadable_get_type())
#define U_OBJECT_LOADABLE(obj) G_TYPE_CHECK_INSTANCE_CAST(obj, \
	U_OBJECT_TYPE_LOADABLE, UObjectLoadable)
#define U_OBJECT_IS_LOADABLE(obj) G_TYPE_CHECK_INSTANCE_TYPE(obj, \
	U_OBJECT_TYPE_LOADABLE)
#define U_OBJECT_LOADABLE_GET_INTERFACE(inst) G_TYPE_INSTANCE_GET_INTERFACE \
	(inst, U_OBJECT_TYPE_LOADABLE, UObjectLoadable)

typedef struct UObjectLoadable UObjectLoadable;

struct UObjectLoadable {
	GTypeInterface parent;

	int (*load)(GObject *obj);
	void (*unload)(GObject *obj);
};

GType u_object_loadable_get_type(void);

int u_object_load(GObject *obj);
void u_object_unload(GObject *obj);

#endif
